/*	ex1.cc
	Basic polygon drawing test of libcrabclaw
	Copyright (C) 2004 Lawrence Sebald	
	Portions Copyright (C) 2000-2001 by Dan Potter	*/
	
/*	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
	
/*	This is a rewrite of the KOS/libdream ta (3dtest) program
	to libcrabclaw */
	
#include <ccvideo.h>
#include <ccvertex.h>
#include <time.h>

using namespace crabclaw;

/* From here to main copied verbatim from the 3dtest program */
typedef struct {
	float	x, y, z;
	float	dx, dy;
} polyplace_t;

polyplace_t polys[12] = {
	{ 16.0f, 0.0f, 10.0f, 3.0f, 5.0f },	/* Top */
	{ 300.0f, 0.0f, 11.0f, 0.0f, 6.0f },
	{ 624.0f, 0.0f, 12.0f, -3.0f, 7.0f },
	
	{ 24.0f, 300.0f, 13.0f, 3.0f, -7.0f },	/* Bottom */
	{ 340.0f, 300.0f, 14.0f, 0.0f, -6.0f },
	{ 616.0f, 300.0f, 15.0f, -3.0f, -5.0f },
	
	{ 0.0f, 16.0f, 16.0f, 5.0f, 3.0f },	/* Left */
	{ 0.0f, 220.0f, 17.0f, 6.0f, 0.0f },
	{ 0.0f, 364.0f, 18.0f, 7.0f, -3.0f },
	
	{ 480.0f, 24.0f, 19.0f, -7.0f, 3.0f },	/* Right */
	{ 480.0f, 260.0f, 20.0f, -6.0f, 0.0f },
	{ 480.0f, 356.0f, 21.0f, -5.0f, -3.0f },
};

/* Does one frame of polygon movement */
void move_polys() {
	int i;
	polyplace_t *p;
	
	for (i=0; i<12; i++) {
		p = polys+i;
		
		p->x += p->dx;
		if (p->x < 0 || p->x > 580.0f) {
			p->dx = -p->dx;
			p->x += p->dx;
		}

		p->y += p->dy;
		if (p->y < 0 || p->y > 420.0f) {
			p->dy = -p->dy;
			p->y += p->dy;
		}
	}
}

/* Here starts my code */
int main(int argc, char * argv[])	{
	ccScreen *scr = new ccScreen(0, 0, 640, 480, 16, "Crabclaw example 1");
	int i;
	time_t t = time(NULL);
	
	while(t + 360 > time(NULL))	{
		scr->beginScene();
		scr->beginList(ccScreen::LIST_OPAQUE);
		scr->beginPoly();
		for(i = 0; i < 12; i++)	{
			scr->submitVertex(ccVertex(ccVertex::NORMAL_VERT, polys[i].x, polys[i].y + 200, polys[i].z, 0, 0, 0xFF0000FF));
			scr->submitVertex(ccVertex(ccVertex::NORMAL_VERT, polys[i].x, polys[i].y, polys[i].z, 0, 0, 0xFF00FF00));
			scr->submitVertex(ccVertex(ccVertex::NORMAL_VERT, polys[i].x + 200, polys[i].y + 200, polys[i].z, 0, 0, 0xFF000000));
			scr->submitVertex(ccVertex(ccVertex::END_VERT, polys[i].x + 200, polys[i].y, polys[i].z, 0, 0, 0xFFFF0000));
		}
		scr->finishPoly();
		scr->finishList();
		scr->finishScene();
		move_polys();
	} 
	
	delete scr;
	
	return 0;
}
