/*	ex3.cc
	ccSprite example libcrabclaw
	libcrabclaw
	Copyright (C) 2004 Lawrence Sebald
	Portions Copyright (C) 2000-2001 Dan Potter	*/
	
/*	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
	
/*	This is a rewrite of the KOS/libdream ta (3dtest) (by Dan Potter) program
	to libcrabclaw with the scene manager, and a test of the ccSprite class */
	
#include <ccvideo.h>
#include <ccscenemgr.h>
#include <ccvertex.h>
#include <ccpolygon.h>
#include <ccsprite.h>
#include <png/png.h>
	
using namespace crabclaw;

/* up until the variables before sm_callback is adapted from 3dtest */
typedef struct {
	int	x, y, z;
	int	dx, dy;
} polyplace_t;

polyplace_t polys[12] = {
	{ 16, 0, 10, 3, 5 },	/* Top */
	{ 300, 0, 11, 0, 6 },
	{ 624, 0, 12, -3, 7 },
	
	{ 24, 300, 13, 3, -7 },	/* Bottom */
	{ 340, 300, 14, 0, -6 },
	{ 616, 300, 15, -3, -5 },
	
	{ 0, 16, 16, 5, 3 },	/* Left */
	{ 0, 220, 17, 6, 0 },
	{ 0, 364, 18, 7, -3 },
	
	{ 480, 24, 19, -7, 3 },	/* Right */
	{ 480, 260, 20, -6, 0 },
	{ 480, 356, 21, -5, -3 },
};

int num = 0;
/* Does one frame of polygon movement */
void move_polys(ccMovingPoly& poly) {
	polyplace_t *p;
	
	if(num == 12)	{
		num = 0;
	}
	
	p = &polys[num];
	
	p->x += p->dx;
	if (p->x < 0 || p->x > 580.0f) {
		p->dx = -p->dx;
		p->x += p->dx;
	}

	p->y += p->dy;
	if (p->y < 0 || p->y > 420.0f) {
		p->dy = -p->dy;
		p->y += p->dy;
	}
	
	poly.setVertex(0, new ccVertex(ccVertex::NORMAL_VERT, polys[num].x, polys[num].y + 200, polys[num].z, 0.0f, 0.0f, 0xFF0000FF));
	poly.setVertex(1, new ccVertex(ccVertex::NORMAL_VERT, polys[num].x, polys[num].y, polys[num].z, 0.0f, 0.0f, 0xFF00FF00));
	poly.setVertex(2, new ccVertex(ccVertex::NORMAL_VERT, polys[num].x + 200, polys[num].y + 200, polys[num].z, 0.0f, 0.0f, 0xFF000000));
	poly.setVertex(3, new ccVertex(ccVertex::END_VERT, polys[num].x + 200, polys[num].y, polys[num].z, 0.0f, 0.0f, 0xFFFF0000));	
	num++;	
}

ccSprite *spr;

int fcount;
int x, y;
time_t tm;
bool spinny = false;
int spinnyleft = 8;

void sm_callback(ccSceneManager *sm)	{
	fcount++;
	if(spinny)	{
		if((fcount % 10) == 0)	{
			y++;
			spinnyleft--;
		}
		if(y > 3)	{
			y = 0;
		}
		if(spinnyleft == 0)	{
			spinnyleft = 8;
			spinny = false;
		}
		spr->setDisplayed(x, y);
		return;
	}
	
	if((fcount % 960) == 0)	{
		spinny = true;
	}	
		
	if((fcount % 30) == 0)	{
		x = 0;
	}
	else if((fcount % 15) == 0)	{
		x = 1;
	}
	if((fcount % 120) == 0)	{
		y++;
	}
	if(y > 3)	{
		y = 0;
	}
	
	spr->setDisplayed(x, y);
}

int main(int argc, char *argv[])	{
	ccScreen *scr = new ccScreen(0, 0, 640, 480, 16, "Crabclaw example 3");
	int i;
	ccSceneManager *scm = new ccSceneManager(sm_callback, scr);
	ccMovingPoly *mp;
	pvr_ptr_t txr;
	uint32 w = 32, h = 64;
	
	txr = pvr_mem_malloc(32 * 64 * 2);
	
//	png_to_texture("/pc/fighter.png", txr, PNG_FULL_ALPHA);
	
	for(i = 0; i < 12; i++)	{
		mp = new ccMovingPoly(ccScreen::LIST_TRANSLUCENT, move_polys);
		mp->addVertex(new ccVertex(ccVertex::NORMAL_VERT, polys[i].x, polys[i].y + 200, polys[i].z, 0.0f, 0.0f, 0xFF0000FF));
		mp->addVertex(new ccVertex(ccVertex::NORMAL_VERT, polys[i].x, polys[i].y, polys[i].z, 0.0f, 0.0f, 0xFF00FF00));
		mp->addVertex(new ccVertex(ccVertex::NORMAL_VERT, polys[i].x + 200, polys[i].y + 200, polys[i].z, 0.0f, 0.0f, 0xFF000000));
		mp->addVertex(new ccVertex(ccVertex::END_VERT, polys[i].x + 200, polys[i].y, polys[i].z, 0.0f, 0.0f, 0xFFFF0000));
		scm->add(mp);
	}
	
//	ccTexture *tex = new ccTexture(txr, w, h, ccTexture::TXRFMT_ARGB4444);
	ccTexture *tex = ccTexture::createFromPNG("/pc/fighter.png");
	
	spr = new ccSprite(tex, 0.5f, 0.25f, ccScreen::LIST_TRANSLUCENT);
	spr->setPos(320, 240, 25);
	spr->setDimensions(128, 128);
	
	tm = time(NULL);
	
	scm->add(spr);
	
	scm->run();
}
