/*	ex5.cc
	ccSelectorMenu demo
	libcrabclaw
	Copyright (C) 2004 Lawrence Sebald	*/

/*	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <ccmenu.h>
#include <ccline.h>
#include <ccfont.h>
#include <ccvideo.h>
#include <cctimer.h>
#include <ccvertex.h>
#include <ccsprite.h>
#include <cctexture.h>
#include <ccpolygon.h>
#include <cccontroller.h>

using namespace crabclaw;
/* and now for something completely different.... */

ccSprite *spr[4];
ccSelectorMenu *selmen;
ccTTFFont *f;
ccController *c1;

void addLines()	{
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 32, 48, 48, 32, 5, 3, 0xFFFFFFFF, 3));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 32, 320, 48, 304, 5, 3, 0xFFFFFFFF, 3));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 208, 48, 224, 32, 5, 3, 0xFFFFFFFF, 3));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 208, 272, 224, 256, 5, 3, 0xFFFFFFFF, 3));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 416, 48, 432, 32, 5, 3, 0xFFFFFFFF, 3));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 416, 272, 432, 256, 5, 3, 0xFFFFFFFF, 3));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 48, 264, 32, 248, 5, 3, 0xFFFFFFFF, 3));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 48, 448, 32, 432, 5, 3, 0xFFFFFFFF, 3));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 224, 224, 208, 208, 5, 3, 0xFFFFFFFF, 3));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 224, 448, 208, 432, 5, 3, 0xFFFFFFFF, 3));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 432, 224, 416, 208, 5, 3, 0xFFFFFFFF, 3));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 432, 448, 416, 432, 5, 3, 0xFFFFFFFF, 3));
		
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 192, 48, 176, 32, 5, 3, 0xFFFFFFFF, 3));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 192, 320, 176, 304, 5, 3, 0xFFFFFFFF, 3));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 400, 48, 384, 32, 5, 3, 0xFFFFFFFF, 3));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 400, 272, 384, 256, 5, 3, 0xFFFFFFFF, 3));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 608, 48, 592, 32, 5, 3, 0xFFFFFFFF, 3));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 608, 272, 592, 256, 5, 3, 0xFFFFFFFF, 3));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 176, 264, 192, 248, 5, 3, 0xFFFFFFFF, 3));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 176, 448, 192, 432, 5, 3, 0xFFFFFFFF, 3));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 384, 224, 400, 208, 5, 3, 0xFFFFFFFF, 3));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 384, 448, 400, 432, 5, 3, 0xFFFFFFFF, 3));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 592, 224, 608, 208, 5, 3, 0xFFFFFFFF, 3));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 592, 448, 608, 432, 5, 3, 0xFFFFFFFF, 3));
	
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 48, 32, 176, 32, 5, 3, 0xFFFFFFFF, 0));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 48, 264, 176, 264, 5, 3, 0xFFFFFFFF, 0));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 48, 304, 176, 304, 5, 3, 0xFFFFFFFF, 0));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 48, 448, 176, 448, 5, 3, 0xFFFFFFFF, 0));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 224, 32, 384, 32, 5, 3, 0xFFFFFFFF, 0));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 224, 224, 384, 224, 5, 3, 0xFFFFFFFF, 0));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 224, 256, 384, 256, 5, 3, 0xFFFFFFFF, 0));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 224, 448, 384, 448, 5, 3, 0xFFFFFFFF, 0));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 432, 32, 592, 32, 5, 3, 0xFFFFFFFF, 0));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 432, 224, 592, 224, 5, 3, 0xFFFFFFFF, 0));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 432, 256, 592, 256, 5, 3, 0xFFFFFFFF, 0));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 432, 448, 592, 448, 5, 3, 0xFFFFFFFF, 0));	
	
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 32, 48, 32, 248, 5, 3, 0xFFFFFFFF, 1));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 192, 48, 192, 248, 5, 3, 0xFFFFFFFF, 1));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 32, 320, 32, 432, 5, 3, 0xFFFFFFFF, 1));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 192, 320, 192, 432, 5, 3, 0xFFFFFFFF, 1));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 208, 48, 208, 208, 5, 3, 0xFFFFFFFF, 1));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 400, 48, 400, 208, 5, 3, 0xFFFFFFFF, 1));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 208, 272, 208, 432, 5, 3, 0xFFFFFFFF, 1));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 400, 272, 400, 432, 5, 3, 0xFFFFFFFF, 1));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 416, 48, 416, 208, 5, 3, 0xFFFFFFFF, 1));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 608, 48, 608, 208, 5, 3, 0xFFFFFFFF, 1));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 416, 272, 416, 432, 5, 3, 0xFFFFFFFF, 1));
	selmen->add(new ccLine(ccScreen::LIST_OPAQUE, 608, 272, 608, 432, 5, 3, 0xFFFFFFFF, 1));
}

void addText()	{
	ccTextString *ts = new ccTextString(f, "Items\n"
	                                       "Equip\n"
	                                       "Magic\n"
	                                       "Skills\n"
	                                       "Stats\n"
	                                       "Save\n"
	                                       "Quit\n", 24);
	ts->setPosition(64, 82);
	
	ccTextString *ts1 = new ccTextString(f, "L.J.", 18);
	ts1->setPosition(224, 112);
	ccTextString *ts2 = new ccTextString(f, "Jon", 18);
	ts2->setPosition(432, 112);
	ccTextString *ts3 = new ccTextString(f, "T.C.", 18);
	ts3->setPosition(224, 336);
	ccTextString *ts4 = new ccTextString(f, "Nick", 18);
	ts4->setPosition(432, 336);
	
	ccTextString *ts11 = new ccTextString(f, "HP: 30/30", 16);
	ts11->setPosition(224, 176);
	ccTextString *ts12 = new ccTextString(f, "HP: 25/25", 16);
	ts12->setPosition(432, 176);
	ccTextString *ts13 = new ccTextString(f, "HP: 20/20", 16);
	ts13->setPosition(224, 400);
	ccTextString *ts14 = new ccTextString(f, "HP: 22/22", 16);
	ts14->setPosition(432, 400);
	
	ccTextString *ts21 = new ccTextString(f, "MP: 0/0", 16);
	ts21->setPosition(224, 192);
	ccTextString *ts22 = new ccTextString(f, "MP: 0/0", 16);
	ts22->setPosition(432, 192);
	ccTextString *ts23 = new ccTextString(f, "MP: 10/10", 16);
	ts23->setPosition(224, 416);
	ccTextString *ts24 = new ccTextString(f, "MP: 10/10", 16);
	ts24->setPosition(432, 415);
	
	ccTextString *ts31 = new ccTextString(f, "Fighter", 16);
	ts31->setPosition(224, 128);
	ccTextString *ts32 = new ccTextString(f, "Thief", 16);
	ts32->setPosition(432, 128);
	ccTextString *ts33 = new ccTextString(f, "Black Mage", 16);
	ts33->setPosition(224, 352);
	ccTextString *ts34 = new ccTextString(f, "White Mage", 16);
	ts34->setPosition(432, 352);
	
	ccTextString *ts41 = new ccTextString(f, "Level 1", 16);
	ts41->setPosition(224, 160);
	ccTextString *ts42 = new ccTextString(f, "Level 1", 16);
	ts42->setPosition(432, 160);
	ccTextString *ts43 = new ccTextString(f, "Level 1", 16);
	ts43->setPosition(224, 384);
	ccTextString *ts44 = new ccTextString(f, "Level 1", 16);
	ts44->setPosition(432, 384);
	
	ccTextString *gt = new ccTextString(f, "Gold:\n"
	                                       "200 G\n\n"
	                                       "Time:\n"
	                                       "0:01:37", 16);
	gt->setPosition(64, 336);
	
	selmen->add(ts);
	selmen->add(ts1);
	selmen->add(ts2);
	selmen->add(ts3);
	selmen->add(ts4);
	selmen->add(ts11);
	selmen->add(ts12);
	selmen->add(ts13);
	selmen->add(ts14);
	selmen->add(ts21);
	selmen->add(ts22);
	selmen->add(ts23);
	selmen->add(ts24);
	selmen->add(ts31);
	selmen->add(ts32);
	selmen->add(ts33);
	selmen->add(ts34);
	selmen->add(ts41);
	selmen->add(ts42);
	selmen->add(ts43);
	selmen->add(ts44);
	selmen->add(gt);
}

void addSprites()	{
	ccSprite *sp0 = new ccSprite(ccTexture::createFromPNG("/pc/sp0.png"), 1, 1, ccScreen::LIST_TRANSLUCENT);
	ccSprite *sp1 = new ccSprite(ccTexture::createFromPNG("/pc/sp1.png"), 1, 1, ccScreen::LIST_TRANSLUCENT);
	ccSprite *sp2 = new ccSprite(ccTexture::createFromPNG("/pc/sp2.png"), 1, 1, ccScreen::LIST_TRANSLUCENT);
	ccSprite *sp3 = new ccSprite(ccTexture::createFromPNG("/pc/sp3.png"), 1, 1, ccScreen::LIST_TRANSLUCENT);
	
	sp0->setDimensions(32, 32);
	sp1->setDimensions(32, 32);
	sp2->setDimensions(32, 32);
	sp3->setDimensions(32, 32);
	
	sp0->setPos(224, 48, 5);
	sp1->setPos(432, 48, 5);
	sp2->setPos(224, 270, 5);
	sp3->setPos(432, 270, 5);
	
	selmen->add(sp0);
	selmen->add(sp1);
	selmen->add(sp2);
	selmen->add(sp3);
}

void event_hnd(int e, void *param)	{
	uint64 *ts = (uint64 *) param;
	
	c1->poll();
	
	if(c1->isPressed(3))	{
		selmen->stop();
	}
	
	if(c1->isPressed(4) && *ts + 200 < ccTimer::getMilliseconds())	{
		if(e != 0)
			selmen->decrementSelected();
		else
			selmen->setSelected(6);
		*ts = ccTimer::getMilliseconds();
	}
	
	if(c1->isPressed(5) && *ts + 200 < ccTimer::getMilliseconds())	{
		if(e != 6)
			selmen->incrementSelected();
		else
			selmen->setSelected(0);
		*ts = ccTimer::getMilliseconds();
	}
	
#ifdef _arch_dreamcast
	if(c1->isPressed(2) && *ts + 200 < ccTimer::getMilliseconds())	{
		vid_screen_shot("/pc/crabclaw-20040809.raw");
	}
#endif
}

int main(int argc, char *argv)	{
	uint64 ts = ccTimer::getMilliseconds();
	
	ccScreen *scr = new ccScreen(0, 0, 640, 480, 16, "Crabclaw example 5");
	ccMovingPoly *mp = new ccMovingPoly(ccScreen::LIST_OPAQUE, NULL);
	
	mp->addVertex(new ccVertex(ccVertex::NORMAL_VERT, 40, 80, 5));
	mp->addVertex(new ccVertex(ccVertex::NORMAL_VERT, 40, 56, 5));
	mp->addVertex(new ccVertex(ccVertex::END_VERT, 56, 68, 5));
	
	c1 = new ccController(0);
	
	selmen = new ccSelectorMenu(scr, mp, 0, 40, 56, 0, 26, event_hnd, &ts);
	f = new ccTTFFont("/pc/axaxax.ttf", 16);
	
	addLines();
	addText();
	addSprites();
	
	selmen->run();
	
	delete selmen;
	delete f;
	delete scr;
	delete c1;
	
	return 0;
}	
	