/*	dccontroller.cc
	Controller functions
	libcrabclaw
	Copyright (C) 2004 Lawrence Sebald	*/
	
/*	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
	
#include <cccontroller.h>

namespace crabclaw	{
	ccController::ccController(int num)	{
		cont_num = num;
		num_buttons = 12;
		num_axis = 6;
		axis = new int32[6];
		buttons = 0;
		axis[0] = 0;
		axis[1] = 0;
		axis[2] = 0;
		axis[3] = 0;
		axis[4] = 0;
		axis[5] = 0;
	}
	
	ccController::~ccController()	{
		delete axis;
	}
	
	void ccController::poll()	{
		cont_state_t *state;

		state = (cont_state_t *) maple_dev_status(maple_enum_type(cont_num, MAPLE_FUNC_CONTROLLER));
		
		if(state != NULL)	{
			buttons = state->buttons;
			axis[0] = state->joyx;
			axis[1] = state->joyy;
			axis[2] = state->ltrig;
			axis[3] = state->rtrig;
			axis[4] = state->joy2x;
			axis[5] = state->joy2y;
		}
		else	{
			buttons = axis[0] = axis[1] = axis[2] = axis[3] = axis[4] = axis[5] = 0;
		}
	}
	
}
